'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDom = require('react-dom');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Modal = function (_React$Component) {
	_inherits(Modal, _React$Component);

	function Modal(props) {
		_classCallCheck(this, Modal);

		var _this = _possibleConstructorReturn(this, (Modal.__proto__ || Object.getPrototypeOf(Modal)).call(this, props));

		_this.closeCallback = _this.closeCallback.bind(_this);
		_this.globalMouseClick = _this.globalMouseClick.bind(_this);
		_this.globalKeypress = _this.globalKeypress.bind(_this);
		return _this;
	}

	_createClass(Modal, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			this.popup = document.createElement('div');
			document.body.appendChild(this.popup);
			this.renderLayer();

			if (this.props.open) {
				this.addEventListeners();
			}
		}
	}, {
		key: 'componentDidUpdate',
		value: function componentDidUpdate(prevProps) {
			if (prevProps.open !== this.props.open) {
				this.renderLayer();

				if (!prevProps.open && this.props.open) {
					document.body.style.overflow = 'hidden';
					this.addEventListeners();
				} else {
					document.body.style.overflow = 'auto';
					this.removeEventListeners();
				}
			}
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			if (document.body) {
				document.body.removeChild(this.popup);
			}

			this.removeEventListeners();
		}
	}, {
		key: 'globalMouseClick',
		value: function globalMouseClick(e) {
			if ((e.target.className == this.props.customClassNames.holder || e.target.className == this.props.customClassNames.background) && this.props.closeOnClickOutside) {
				this.props.onCloseCallback({
					open: false
				});
			}
		}
	}, {
		key: 'globalKeypress',
		value: function globalKeypress(e) {
			if (e.keyCode == 27 && !this.props.ignoreEsc) {
				this.props.onCloseCallback({
					open: false
				});
			}
		}
	}, {
		key: 'closeCallback',
		value: function closeCallback(e) {
			e.preventDefault();
			this.props.onCloseCallback({
				open: false
			});
		}
	}, {
		key: 'addEventListeners',
		value: function addEventListeners() {
			window.addEventListener('click', this.globalMouseClick);
			window.addEventListener('keyup', this.globalKeypress);
		}
	}, {
		key: 'removeEventListeners',
		value: function removeEventListeners() {
			window.removeEventListener('click', this.globalMouseClick);
			window.removeEventListener('keyup', this.globalKeypress);
		}
	}, {
		key: 'createModalWrapper',
		value: function createModalWrapper(content) {
			return _react2.default.createElement(
				'div',
				null,
				this.props.open && _react2.default.createElement(
					'div',
					{
						style: this.props.style && this.props.style.background,
						className: this.props.customClassNames.background || Modal.defaultProps.customClassNames.background
					},
					_react2.default.createElement(
						'div',
						{
							style: this.props.style && this.props.style.holder,
							className: this.props.customClassNames.holder || Modal.defaultProps.customClassNames.holder
						},
						_react2.default.createElement(
							'div',
							{
								style: this.props.style && this.props.style.modal,
								className: this.props.customClassNames.modal || Modal.defaultProps.customClassNames.modal
							},
							content
						)
					)
				)
			);
		}
	}, {
		key: 'renderLayer',
		value: function renderLayer() {
			(0, _reactDom.render)(this.createModalWrapper(this.props.children), this.popup);
		}
	}, {
		key: 'render',
		value: function render() {
			return _react2.default.createElement('div', null);
		}
	}]);

	return Modal;
}(_react2.default.Component);

exports.default = Modal;


Modal.propTypes = {
	open: _propTypes2.default.bool,
	onCloseCallback: _propTypes2.default.func.isRequired,
	style: _propTypes2.default.object,
	customClassNames: _propTypes2.default.object,
	closeOnClickOutside: _propTypes2.default.bool,
	ignoreEsc: _propTypes2.default.bool
};

Modal.defaultProps = {
	customClassNames: {
		background: 'ReactComboModalBackground',
		holder: 'ReactComboModalHolder',
		modal: 'ReactComboModal'
	}
};
